-- set search_path
set search_path to public;

-- define table
create table tbl(
	a char varying(10) not null,
	b char varying(10) not null,
	c char varying(10) not null,
	d char varying(10) not null,
	e char varying(10) not null,
	f char varying(10) not null,
	g char varying(10) not null,
	h int not null,
	i char varying(10) not null,
	j bigint not null,
	k char varying(10) not null,
	l char varying(10) not null,
	m char varying(10) not null,
	primary key (a, b, c, d, e, h));
create index tbl_ix1 on tbl (a, b, c, d, h, l, m);

-- insert test data
insert into tbl values (
	'1000000000',
	'1000000000',
	'1000000000',
	'1000000000',
	'1000000000',
	'1000000000',
	'1000000000',
	1,
	'1000000000',
	1,
	'1000000000',
	'1000000000',
	'1000000000');

analyze;

-- update pg_class and pg_statistic
begin;
update pg_class
     set relpages = 200000,
	 reltuples = 9.612e+06,
	 relallvisible = 0
where relname = 'tbl';

update pg_class
     set relpages = 60000,
	 reltuples = 9.612e+06,
         relallvisible = 0
where relname = 'tbl_pkey';

update pg_class
     set relpages = 70000,
	 reltuples = 9.612e+06,
       	 relallvisible = 0
where relname = 'tbl_ix1';

update pg_statistic
     set stanullfrac = 0,
         stadistinct = 0,
         stakind1 = 0,
         stakind2 = 0,
         stakind3 = 0,
         stakind4 = 0,
         stakind5 = 0,
         staop1 = 0,
         staop2 = 0,
         staop3 = 0,
         staop4 = 0,
         staop5 = 0,
         stanumbers1 = NULL,
         stanumbers2 = NULL,
         stanumbers3 = NULL,
         stanumbers4 = NULL,
         stanumbers5 = NULL,
         stavalues1 = NULL,
         stavalues2 = NULL,
         stavalues3 = NULL,
         stavalues4 = NULL,
         stavalues5 = NULL,
         stawidth = 61
where starelid = (select starelid from pg_statistic s, pg_class c
                  where c.oid = s.starelid and relname = 'tbl'
group by starelid);

-- lock statistic
select dbms_stats.lock_database_stats();

-- set curpages on relation_stats_locked
update dbms_stats.relation_stats_locked
   set curpages= 200000
where relname = 'public.tbl';

update dbms_stats.relation_stats_locked
   set curpages= 60000
where relname = 'public.tbl_pkey';

update dbms_stats.relation_stats_locked
   set curpages= 70000
where relname = 'public.tbl_ix1';

commit;

-- select
explain analyze select a from public.tbl
where a='1000000000' and
      b='1000000000' and
      c='1000000000' and
      d='1000000000' and
      e='1000000000' and
      h=1;

-- unlock stats
select dbms_stats.unlock_database_stats();
analyze;

-- drop table
drop table tbl;
